﻿using System;
using System.Windows.Forms;
using AIOWDMNet;

namespace mPCIe_DIO_24s
{

    public partial class AIOWDMLog : Form
    {
        // Prototype AIOWDM.dll data and functions in managed C# for Dot Net
        // Using C# data types and default marshaling of unmanaged code

        // Predefined constants for device index:
        public const UInt32 diNone = 0xFFFFFFFF;    // "-1"
        public const UInt32 diFirst = 0xFFFFFFFE;   // "-2"  First board
        public const UInt32 diOnly = 0xFFFFFFFD;    // "-3"  One and only board 

        public const UInt32 TIME_METHOD_NOW = 0;
        public const UInt32 TIME_METHOD_WAIT_INPUT_ENABLE = 86;
        public const UInt32 TIME_METHOD_NOW_AND_ABORT = 5;
        public const UInt32 TIME_METHOD_WHEN_INPUT_ENABLE = 1;

        // Watchdog function constants:
        public const UInt32 WDG_ACTION_IGNORE = 0;
        public const UInt32 WDG_ACTION_DISABLE = 1;
        public const UInt32 WDG_ACTION_SOFT_RESTART = 2;
        public const UInt32 WDG_ACTION_MOSTLY_SOFT_RESTART = 4;
        public const Double PCI_WDG_CSM_RATE = 2.08333;
        public const Double P104_WDG_CSM_RATE = 2.08333;
        public const Double ISA_WDG_CSM_RATE = 0.894886;


        // In ports API's
        public UInt16 RelInPortB(Int32 CardNum, UInt32 offset, String message = "")
        {
            ushort valueRead = AIOWDM.RelInPortB(CardNum, offset);
            Log.Items.Add(string.Format("read 8 from +{1:x} received: {2:x} note: {3}", CardNum, offset, valueRead, message));

            return valueRead;
        }

        public UInt16 RelInPort(Int32 CardNum, UInt32 offset, String message = "")
        {
            ushort valueRead = AIOWDM.RelInPort(CardNum, offset);
            Log.Items.Add(string.Format("read16 from +{1:x} received: {2:x} note: {3}", CardNum, offset, valueRead, message));

            return valueRead;
        }

        public UInt32 RelInPortL(Int32 CardNum, UInt32 offset, String message = "")
        {
            var valueRead = AIOWDM.RelInPortL(CardNum, offset);
            Log.Items.Add(string.Format("read32 from +{1:x} received: {2:x} note: {3}", CardNum, offset, valueRead, message));

            return valueRead;
        }

        // Out ports API's
        public UInt16 RelOutPortB(Int32 CardNum, UInt32 offset, Byte Value, String message = "")
        {
            var valueReturned = AIOWDM.RelOutPortB(CardNum, offset, Value);
            Log.Items.Add(string.Format("write B to +{1:x} of {2:x} note {4}", CardNum, offset, Value, valueReturned, message));
            return valueReturned;
        }

        public UInt16 RelOutPort(Int32 CardNum, UInt32 offset, UInt16 Value, String message = "")
        {
            var valueReturned = AIOWDM.RelOutPort(CardNum, offset, Value);
            Log.Items.Add(string.Format("write16 to +{1:x} of {2:x} note {4}", CardNum, offset, Value, valueReturned, message));
            return valueReturned;
        }

        public UInt16 RelOutPortL(Int32 CardNum, UInt32 offset, UInt32 Value, String message = "")
        {
            var valueReturned = AIOWDM.RelOutPortL(CardNum, offset, Value);
            Log.Items.Add(string.Format("write32 to +{1:x} of {2:x} note {4}", CardNum, offset, Value, valueReturned, message));
            return valueReturned;
        }

        public AIOWDMLog()
        {
            InitializeComponent();
        }
    }
}
